using System;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using AjaxControlToolkit;
using System.Data;
using System.Data.SqlClient;

/// <summary>
/// Summary description for CarsService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.Web.Script.Services.ScriptService]
public class CarsService : System.Web.Services.WebService {

    public CarsService () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public string HelloWorld() {
        return "Hello World";
    }

    // Web method to get all the car models for a given carId
    // In params: knownCategoryValues from the cascading dropdown
    // Out params: CascadingDropDownNameValue array
    [WebMethod]
    public CascadingDropDownNameValue[] GetModelsByCarId(string knownCategoryValues,
        string category)
    {
        // Split the knownCategoryValues on ":" with ";" delimiter 
        // For the first dropdownlist, the values will be "undefined: id of the dropdownelement"
        // ex: "undefined: 13;"
        // The string at index 1 will be the CarId selected in the dropdownlist.
        string[] _categoryValues = knownCategoryValues.Split(':', ';');
        // Convert the element at index 1 in the string[] to get the CarId
        int _carID = Convert.ToInt32(_categoryValues[1]);
        // Create a List<T> of CascadingDropDownNameValue to hold the CarModels data
        List<CascadingDropDownNameValue> _carModels = new List<CascadingDropDownNameValue>();
        // Create an instance of CarModels TableAdapter
        dsCarModelsTableAdapters.CarModelsTableAdapter _carModelAdapter = new dsCarModelsTableAdapters.CarModelsTableAdapter();
        // For each datarow in the DataTable returned by the GetModelsByCarId method, add the modelname and modelid to the List<T>
        foreach (DataRow _row in _carModelAdapter.GetModelsByCarId(_carID))
        {
            _carModels.Add(new CascadingDropDownNameValue(_row["ModelName"].ToString(), _row["ModelId"].ToString()));
        }
        // convert to array and return the vlaues
        return _carModels.ToArray();
    }
}

